Public Class Form1

Private [Step] As Integer

Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
  Dim Args As String = LTrim(Command$()) & "        "
  If Args.StartsWith("step=2") Then
    Me.Text &= " -  2 -  "
    [Step] = 2
    TxtCmd.Text = Trim(Args.Substring(8))
    TxtArgs.Text = ""
    TxtUser.Enabled = False
    TxtPass.Enabled = False
    TxtDomain.Enabled = False
    ChkAuto.Checked = False
    ChkAuto.Enabled = False
    If Args.Chars(6) = "a"c Then
      ChkAuto.Checked = True
      BtnOk_Click(sender, e)
    End If
  Else
    Me.Text &= " -  1 -    "
    [Step] = 1
    TxtCmd.Text = My.Application.Info.DirectoryPath & "\" & My.Application.Info.AssemblyName & ".exe"
    If Args.StartsWith("step=1 ") Then
      TxtArgs.Text = "step=2  " & Trim(Args.Substring(8))
    Else
      TxtArgs.Text = "step=2  " & Args
    End If
    TxtCmd.Enabled = False
    TxtArgs.Enabled = False
    ChkAuto.Checked = True
  End If
End Sub

Private Sub ChkSilent_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChkAuto.Click, ChkAuto.CheckedChanged
  If [Step] = 1 Then
    If ChkAuto.Checked Then
      If TxtArgs.Text.Length > 8 Then
        TxtArgs.Text = TxtArgs.Text.Substring(0, 6) & "a " & TxtArgs.Text.Substring(8)
      Else
        TxtArgs.Text = TxtArgs.Text.Substring(0, 6) & "a "
      End If
    Else
      If TxtArgs.Text.Length > 8 Then
        TxtArgs.Text = TxtArgs.Text.Substring(0, 6) & "  " & TxtArgs.Text.Substring(8)
      Else
        TxtArgs.Text = TxtArgs.Text.Substring(0, 6) & "  "
      End If
    End If
  End If
End Sub

Private Sub BtnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnOk.Click
  Dim Prc As New System.Diagnostics.Process
  Try
    With Prc.StartInfo
      .FileName = Trim(TxtCmd.Text())
      .Arguments = Trim(TxtArgs.Text)
      If [Step] = 1 Then
        .UserName = Trim(TxtUser.Text)
        .Password = StringToSecureString(TxtPass.Text)
        .Domain = Trim(TxtDomain.Text)
        .UseShellExecute = False
      Else
        .UseShellExecute = True
      End If
    End With
    Prc.Start()
  Catch ex As Exception
    If MsgBox("  ." & vbCrLf & "?", MsgBoxStyle.YesNo Or MsgBoxStyle.Critical, "") = MsgBoxResult.No Then
      Exit Sub
    End If
  End Try
  Me.Close()
End Sub

Private Sub BtnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCancel.Click
  Me.Close()
End Sub

Private Function StringToSecureString(ByVal Str As Char()) As System.Security.SecureString
  Dim Res As New System.Security.SecureString
  For Q As Integer = 0 To Str.Length - 1
    Res.AppendChar(Str(Q))
  Next Q
  Return Res
End Function

End Class
